cryo_agent/publisher/routes/collectors.py
import logging
from copy import copy, deepcopy
from typing import Any

from flask import (
    Blueprint,
    current_app,
    flash,
    redirect,
    render_template,
    request,
    url_for,
)
from sqlalchemy.orm import Session

from cryo_agent.logic.collectors import (
    add_data_group,
    add_data_point,
    add_new_collector,
    delete_collector,
    delete_data_group,
    delete_data_point,
    get_collector,
    get_collectors,
    get_data_group,
    get_data_point,
    is_collector_name_used,
    update_collector,
    update_data_group,
    update_data_point,
)
from cryo_agent.publisher import tasks
from cryo_agent.publisher.db import get_engine
from cryo_agent.utils.exceptions import ObjectNotFoundException
from cryo_agent.utils.types import PluginData

LOGGER = logging.getLogger(__name__)

bp = Blueprint("collectors", __name__, url_prefix="/collectors")


@bp.route("/")
def index():
    with Session(get_engine()) as session:
        collectors = get_collectors(session)
        return render_template(
            "collectors/index.html",
            collectors=collectors,
        )


@bp.route("/add/", methods=["GET", "POST"])
def add_collector():
    registered_plugins: dict[str, dict] = deepcopy(current_app.config.get("REGISTERED_PLUGINS", {}))
    assert isinstance(registered_plugins, dict)

    if request.method == "POST":
        with Session(get_engine()) as session:
            LOGGER.debug("adding new collector!")
            data = request.form
            collector_name = data.get("collector_name")
            collector_class_alias = data.get("collector_class")
            collector_name_used = False

            # Flash messages that entries are requried
            if not collector_name:
                flash("Collector name is requried")
            if not collector_class_alias:
                flash("Collector class is required")
            if collector_name and is_collector_name_used(session, collector_name):
                collector_name_used = True
            if collector_name_used:
                flash(f"Collector name `{collector_name}` is already used")

            if all([collector_name, collector_class_alias, not collector_name_used]):
                LOGGER.debug("Creating new collector!")
                # NOTE: no need to start collector yet, as it is not enabled after creation
                add_new_collector(session, collector_name, collector_class_alias)
                return redirect(url_for("collectors.details_collector", collector_name=collector_name))

    return render_template(
        "collectors/add_collector.html",
        registered_plugins=registered_plugins,
        external_plugins_present=any([not reg_plugin["internal"] for reg_plugin in registered_plugins.values()]),
    )


@bp.route("/<string:collector_name>/", methods=["GET", "POST"])
def details_collector(collector_name: str):
    registered_plugins: dict[str, dict] = deepcopy(current_app.config.get("REGISTERED_PLUGINS", {}))
    assert isinstance(registered_plugins, dict)
    with Session(get_engine()) as session:
        collector = get_collector(session, collector_name)
        if collector is None:
            raise ObjectNotFoundException(f"Could not find collector with name: {collector_name}")

        collector_config = registered_plugins[collector.collector_class]

        if request.method == "POST" and ("save" in request.form or "save_continue" in request.form):
            data: dict[str, Any] = {
                key: item for key, item in request.form.items() if key not in ["save", "save_continue"]
            }
            data["enabled"] = True if "enabled" in data else False

            # Get possible error messages from the collector class
            error_messages = collector_config["plugin_class"].validate_collector_config(
                data,
                collector_config.get("config", {}).get("settings", {}),
            )

            if len(error_messages) != 0:
                for error_message in error_messages:
                    flash(error_message)

                return render_template(
                    "collectors/details.html",
                    collector_name=collector_name,
                    collector_config=collector_config,
                    collector=collector.serialize(),
                )

            # Update settings immediately with open session
            # NOTE, collector_settings is now updated with the newest values
            prev_enabled = copy(collector.enabled)
            update_collector(session, collector_name, data)

            # Enabling collectors is handled by the cryo_agent_process
            if prev_enabled and not data["enabled"]:
                tasks.disable_collector(collector_name)
            elif not prev_enabled and data["enabled"]:
                tasks.enable_collector(collector_name)

            if prev_enabled and data["enabled"]:
                # Only update collector settings when the collector is enabled and remains enabled
                # If any other settings have been changed, send task to the corresponding collector process
                tasks.update_collector_settings(collector_name, {})

            if "save" in request.form:
                return redirect(url_for("collectors.index"))
            if "save_continue" in request.form:
                return redirect(url_for("collectors.details_collector", collector_name=collector_name))

        elif request.method == "POST" and "delete" in request.form:
            delete_collector(session, collector_name)
            tasks.disable_collector(collector_name)
            return redirect(url_for("collectors.index"))

        return render_template(
            "collectors/details.html",
            collector_name=collector_name,
            collector_config=collector_config,
            collector=collector.serialize(),
        )


@bp.route("/<string:collector_name>/datagroups/")
def detail_collector_datagroup(collector_name: str):
    """
    Simple redirect path to make breadcrumbs fully functional
    """
    return redirect(url_for("collectors.details_collector", collector_name=collector_name))


@bp.route("/<string:collector_name>/datagroups/add/", methods=["GET", "POST"])
def add_datagroup(collector_name: str):
    with Session(get_engine()) as session:
        collector = get_collector(session, collector_name)
        if collector is None:
            raise ObjectNotFoundException(f"Could not find collector with name: {collector_name}")

        collector_config = deepcopy(current_app.config.get("REGISTERED_PLUGINS", {}).get(collector.collector_class))

        if request.method == "POST":
            data = {**request.form}
            group_label = data.pop("group_label")

            # Get possible error messages from the collector class
            error_messages = collector_config["plugin_class"].validate_datagroup_config(
                data,
                collector_config.get("config", {}).get("settings", {}),
                key_exceptions=["group_label"],  # Needed, because it was popped earlier
            )
            if len(error_messages) == 0:
                add_data_group(session, collector_name, group_label, data)
                return redirect(url_for("collectors.details_collector", collector_name=collector_name))

            # If error messages are present, show them
            for error_msg in error_messages:
                flash(error_msg)

        return render_template(
            "collectors/details-data-groups-add.html",
            collector_name=collector_name,
            collector_config=collector_config,
        )


@bp.route("/<string:collector_name>/datagroups/<string:group_label>/", methods=["GET", "POST"])
def details_datagroup(collector_name: str, group_label: str):
    with Session(get_engine()) as session:
        collector = get_collector(session, collector_name)
        if collector is None:
            raise ObjectNotFoundException(f"Could not find collector with name: {collector_name}")

        data_group = get_data_group(session, collector.id, group_label)
        if data_group is None:
            raise ObjectNotFoundException(f"Could not find data_group with name: {group_label}")

        collector_config = deepcopy(current_app.config.get("REGISTERED_PLUGINS", {}).get(collector.collector_class))
        data_groups_config = collector_config["config"].get("settings", {}).get("data_groups", {})
        data_points_config = collector_config["config"].get("settings", {}).get("data_points", {})

        if request.method == "POST":
            if "save" in request.form:
                data = {key: item for key, item in request.form.items() if key != "save"}

                # Get possible error messages from the collector class
                error_messages = collector_config["plugin_class"].validate_datagroup_config(
                    data,
                    collector_config.get("config", {}).get("settings", {}),
                    key_exceptions=["group_label"],
                )

                if len(error_messages) == 0:
                    update_data_group(session, collector_name, group_label, data)
                    tasks.update_collector_settings(collector_name, {})
                    return redirect(url_for("collectors.details_collector", collector_name=collector_name))

                # If error messages are present, show them
                for error_msg in error_messages:
                    flash(error_msg)
                    return render_template(
                        "collectors/details-data-group.html",
                        collector_name=collector_name,
                        group_label=group_label,
                        data_group=data_group.serialize(),
                        data_groups_config=data_groups_config,
                        data_points_config=data_points_config,
                    )

cryo_agent/publisher/templates/collectors/add_collector.html
{% extends "collectors/base.html" %}
{% from 'macros/inputs.html' import input, label_with_tooltip %}

{% block content %}
    {% include 'includes/alerts.html' %}
    <div class="collectors-add">
        <h1>Add Collector</h1>
        <form method="post">
            {{ label_with_tooltip("collector_name", {"label": "Collector Name", "description": "Unique name of the collector"}) }}
            <br>
            {{ input("collector_name", none, none) }}
            <br>
            {{ label_with_tooltip("collector_class", {"label": "Collector Class", "description": "Class (alias) of the collector"}) }}
            <br>
            {# Custom select options for this unique case #}
            <select name="collector_class" id="collector_class">
                <option value="" selected disabled hidden>Please choose</option>
                {% if external_plugins_present %}
                    <optgroup label="internal">
                {% endif %}
                {% for collector_class_name, collector_data in registered_plugins.items() if collector_data.internal %}
                    <option value="{{ collector_class_name }}">{{ collector_class_name }}</option>
                {% endfor %}
                {% if external_plugins_present %}
                    </optgroup>
                {% endif %}
                {% if external_plugins_present %}
                    <optgroup label="external">
                        {% for collector_class_name, collector_data in registered_plugins.items() if not collector_data.internal %}
                            <option value="{{ collector_class_name }}">{{ collector_class_name }}</option>
                        {% endfor %}
                    </optgroup>
                {% endif %}
            </select>
            <br>
            <button class="submit-button-3" type="submit">Create Collector</button>
        </form>
    </div>
{% endblock %}

cryo_agent/publisher/templates/collectors/base.html
{% extends "base.html " %}
{% set active_page = "collectors" %}

cryo_agent/publisher/templates/collectors/base_wth_breadcrumbs.html
{% extends "collectors/base.html" %}
{% block main %}
    <div class="main">
        {% include 'components/breadcrumbs.html'%}
        {% block content %}
        {% endblock %}
    </div>
{% endblock %}

cryo_agent/publisher/templates/collectors/details-data-group.html
{% extends "collectors/base.html" %}

{% block main %}
    <div class="collector-details">
        <div class="alert-box">
            {% include 'includes/alerts.html' %}
        </div>
        <div class="collector-details-header">
            <h1>Data Group Details for {{ group_label }}</h1>
        </div>
        <div class="collector-details-data">
            <div class="collector-details-data-base">
                <h2>Data Group Settings</h2>
                <form id="collector-details-data-form" method="post">
                    {% include 'collectors/components/details-data-group.html' %}
                </form>
            </div>
            {% if data_points_config %}
                {% include "collectors/components/details-data-points.html" %}
            {% endif %}
            <div>
                <button class="submit-button-3" type="submit" name="save" form="collector-details-data-form">Save</button>
                <button class="button-red" type="submit" name="delete" form="collector-details-data-form">Delete</button>
            </div>
        </div>
    </div>
{% endblock %}

cryo_agent/publisher/templates/collectors/details-data-groups-add.html
{% extends "collectors/base.html" %}
{% from 'macros/inputs.html' import input, label_with_tooltip %}

{% block content %}
    {% include 'includes/alerts.html' %}
    <div class="collectors-add">
        <h1>Add Datagroup</h1>
        <form method="post">
            {% for key, conf in collector_config.config.settings.data_groups.items() if key != "data_points" %}
                {{ label_with_tooltip(key, conf) }}
                <br>
                {{ input(key, conf, none)}}
                <br>
            {% endfor %}
            <button class="submit-button-3" type="submit">Create Datagroup</button>
        </form>
    </div>
{% endblock %}

cryo_agent/publisher/templates/collectors/details-data-point.html
{% extends "collectors/base.html" %}

{% block main %}
    <div class="collector-details">
        <div class="alert-box">
            {% for message in get_flashed_messages() %}<div class="alert">{{ message }}</div>{% endfor %}
        </div>
        <div class="collector-details-header">
            <h1>Data Point Details for {{ variable_name }}</h1>
        </div>
        <div class="collector-details-data">
            <div class="collector-details-data-base">
                <h2>Data Point Settings</h2>
                <form id="collector-details-data-form" method="post">
                    {% include 'collectors/components/details-data-point.html' %}
                </form>
            </div>
            <div>
                <button class="submit-button-3" type="submit" name="save" form="collector-details-data-form">Save</button>
                <button class="button-red" type="submit" name="delete" form="collector-details-data-form">Delete</button>
            </div>
        </div>
    </div>
{% endblock %}

cryo_agent/publisher/templates/collectors/details-data-points-add.html
{% extends "collectors/base.html" %}
{% from 'macros/inputs.html' import input, label_with_tooltip %}

{% block content %}
    {% include 'includes/alerts.html' %}
    <div class="collectors-add">
        <h1>Add Datapoint</h1>
        <form method="post">
            {% for key, conf in collector_config.config.settings.data_points.items() %}
                {{ label_with_tooltip(key, conf) }}
                <br>
                {{ input(key, conf, none) }}
                <br>
            {% endfor %}
            <button class="submit-button-3" type="submit">Create Data point</button>
        </form>
    </div>
{% endblock %}

cryo_agent/publisher/templates/collectors/details.html
{% extends "collectors/base.html" %}

{% block main %}
    <div class="collector-details">
        <div class="collector-details-header">
            <h1>Collector Details for {{ collector.collector_name }}</h1>
        </div>
        <div class="collector-details-data">
            <div class="alert-box">
                {% include 'includes/alerts.html' %}
            </div>
            <div class="collector-details-data-base">
                <h2>Base Settings</h2>
                <form id="collector-details-data-form" name="collector-details" method="post">
                    {% include 'collectors/components/details-base.html' %}
                </form>
            </div>
            {% if collector_config.config.settings and collector_config.config.settings.base and collector_config.config.settings.base.data_groups %}
                {% include "collectors/components/details-data-groups.html" %}
            {% endif %}
            <div class="collector-details-buttons">
                <button class="submit-button-3" type="submit" name="save" form="collector-details-data-form">Save</button>
                <button class="submit-button-3" type="submit" name="save_continue" form="collector-details-data-form">Save & Continue</button>
                <button class="button-red" type="submit" name="delete" form="collector-details-data-form">Delete</button>
            </div>
        </div>
    </div>
{% endblock %}

cryo_agent/publisher/templates/collectors/index.html
{% extends "collectors/base.html" %}

{% block main %}
    <div class="collectors">
        <div class="collectors-heading">
            <h1>Collectors</h1>
            <p>The collectors collect data from various datasources depending on their collector-class</p>
        </div>
        <div class="collectors-table">
            <table class="collector-table">
                <tr>
                    <th>Collector Name</th>
                    <th>Collector Class</th>
                    <th>Log Level</th>
                    <th>Enabled</th>
                </tr>
                {% for collector in collectors %}
                    <tr>
                        <td>
                            <a href="{{ url_for('collectors.details_collector', collector_name=collector.collector_name) }}">
                                {{ collector.collector_name }}
                            </a>
                        </td>
                        <td>{{ collector.collector_class }}</td>
                        <td>{{ collector.log_level }}</td>
                        <td>{{ collector.enabled }}</td>
                    </tr>
                {% endfor %}
            </table>
            <button class="button-3">
                <a href="{{ url_for('collectors.add_collector') }}">Add Collector</a>
            </button>
        </div>
    </div>
{% endblock %}